import Test.QuickCheck

squares :: [Integer] -> [Integer]
squares xs  =  [ x*x | x <- xs ]

isOdd :: Integer -> Bool
isOdd n = (n `mod` 2 == 1)

odds :: [Integer] -> [Integer]
odds xs  =  [ x | x <- xs, isOdd x ]

sumSqOdd :: [Integer] -> Integer
sumSqOdd xs  =  sum [ x*x | x <- xs, isOdd x ]

prop_sumSqOdd :: [Integer] -> Bool
prop_sumSqOdd xs  =  sum (squares (odds xs)) == sumSqOdd xs
